@{
    ViewBag.Title = "Chat";
    Layout = null;
}

<script src="~/Scripts/jquery-3.4.1.min.js" type="text/javascript"></script>
<link href="~/Content/Site.css" rel="stylesheet" />


<h2>Chat</h2>

<div class="container">

    <div class="row" style="margin-top:50px; margin-left: 50px">
        <div class="form-group">
            @Html.Label("Insert the user to chat with:", htmlAttributes:
           new { @class = "control-label col-md-2", @style = "margin-top: 10px" })
            <div class="col-md-5">
                <input class="form-control" id="username" style="width:200px" />
                <input type="submit" value="Start Chat" class="btn btn-default"
                       style="width: 100px; height: 30px; margin-left: 10px" id="btnStartChat" />
                <input type="submit" value="Close Chat" class="btn btn-default"
                       style="width: 100px; height: 30px; margin-left: 10px" id="btnCloseChat" disabled/>
            </div>
        </div>
    </div>



    <ul id="discussion">
    </ul>
    <input type="text" id="message" autocomplete="off" disabled/>
    <input type="button" id="sendmessage" value="Send" style="width: 80px; height: 30px" disabled/>
    <input type="hidden" id="displayname" value="@Session["First_Name"].ToString()" />
    <input type="hidden" id="sessionuser" value="@Session["Username"].ToString()" />
</div>

<!--Script references. -->
<!--The jQuery library is required and is referenced by default in _Layout.cshtml. -->
<!--Reference the SignalR library. -->
<script src="~/Scripts/jquery.signalR-2.2.2.min.js"></script>
<!--Reference the autogenerated SignalR hub script. -->
<script src="~/signalr/hubs"></script>
<!--SignalR script to update the chat page and send messages.-->
<script>

    $(document).ready(function () {
        $(function () {
            // Reference the auto-generated proxy for the hub.
            var chat = $.connection.chatHub;
            var guestConnId = "";       //Store the guest ID to be used during the chat

            // Create a function that the hub can call back to display messages.
            chat.client.addNewMessageToPage = function (name, message) {
                // Add the message to the page.
                $('#discussion').append('<li><strong>' + htmlEncode(name)
                    + '</strong>: ' + htmlEncode(message) + '</li>');
                $('#discussion').scrollTop($('#discussion').prop('scrollHeight'));
            };

            // Start the connection.
            $.connection.hub.start().done(function () {

                //Store connection id of the user in the database
                $.ajax({
                    url: "/Users/StoreConnectionID",
                    type: "POST",
                    data: { connId: String($.connection.hub.id) },
                    success: function (result) {
                    }
                });

                $('#sendmessage').click(function () {
                    // Call the Send method on the hub.
                    chat.server.send(guestConnId, $('#displayname').val(), $('#message').val());
                    // Clear text box and reset focus for next comment.
                    $('#message').val('').focus();
                });

                //Configuring textbox to send message after press enter on the keyboard
                $('#message').keyup(function (e) {
                    if (e.keyCode == 13) {
                        var message = $('#message').val().trim();

                        //Check if there's some message to be sent
                        if (message.length == 0) {
                            return false;
                        }

                        // Call the Send method on the hub.
                        chat.server.send(guestConnId, $('#displayname').val(), $('#message').val());
                        // Clear text box and reset focus for next comment.
                        $('#message').val('').focus();
                    }
                });

                //Check conditions to start chating
                $("#btnStartChat").click(function () {
                    //Check if the user exists
                    $.ajax({
                        url: "/Users/CheckUser",
                        type: "POST",
                        data: { username: $("#username").val() },
                        success: function (result) {
                            if (String(result) == "True") {
                                //If the user exists, check if it's connected and if it is, get its connection ID
                                $.ajax({
                                    url: "/Users/GetConnectionID",
                                    type: "POST",
                                    data: { username: $("#username").val() },
                                    success: function (getId) {

                                        //Check if getId is null, which happens if the user isn't connected
                                        if (getId.toString() == "") {
                                            alert("The user is not connected!");
                                        }
                                        else {
                                            //If the user is connected, check if it's already chating
                                            $.ajax({
                                                url: "/Users/IsChating",
                                                type: "POST",
                                                data: { username: $("#username").val() },
                                                success: function (isChating) {
                                                    if (String(isChating) == "True") {
                                                        //If the user is chating, show the alert
                                                        alert("The user is already chating!");
                                                    }
                                                    else {
                                                        //If it's not chating, start chat
                                                        guestConnId = String(getId);

                                                        //Update IS_CHATING flag in database of the desired user
                                                        $.ajax({
                                                            url: "/Users/StartChating",
                                                            type: "POST",
                                                            data: {
                                                                username: $("#username").val() }
                                                        });

                                                        //Enable inputs for communication
                                                        $("#sendmessage").removeAttr("disabled");
                                                        $("#message").removeAttr("disabled");
                                                        $("#btnCloseChat").removeAttr("disabled");

                                                        //Disable user txtBox and Start button
                                                        document.getElementById("btnStartChat").setAttribute("disabled", "true");
                                                        document.getElementById("username").setAttribute("disabled", "true");
                                                    }
                                                }
                                            });
                                        }
                                    }
                                });
                            }
                            else {
                                //If the user doesn't exists in database
                                alert("User doesn't exists!");
                            }
                        }
                    });
                });

                //Close the chat
                $("#btnCloseChat").click(function () {
                    chat.server.send(guestConnId, "System", "Connection Closed!");

                    //Update IS_CHATING flag in database to false
                    $.ajax({
                        url: "/Users/StopChating",
                        type: "POST",
                        data: { username: $("#sessionuser").val() }
                    });

                    //Clear connection ID in database
                    $.ajax({
                        url: "/Users/ClearConnectionID",
                        type: "POST",
                        data: { username: $("#sessionuser").val() }
                    });

                    //Come back to the Index View
                    document.location.href = "/Home/Index";
                });
            });
        });

        // This function html-encodes messages for display in the page.
        function htmlEncode(value) {
            var encodedValue = $('<div />').text(value).html();
            return encodedValue;
        }
    });

</script>